from vcCommand import *
import os.path

app = getApplication()
process_node_name = 'ProcessNode'
process_frame_name = 'ProductLocation'
resource_frame_name = 'ResourceLocation'

def OnStart():
  global setup_prop, door_controller_prop, comp, container_prop, state_prop, door_conf_prop, tool_conf_prop, controllers
  global create_works_prop, create_basics_prop, create_connectivity_prop, create_process_prop, node_prop, create_mtending_prop
  
  comp = app.CurrentContext.ActiveComponent
  if not comp:
    print 'Select a component to use this wizard.'
  else:
    tnodes = comp.findBehavioursByType(VC_TRANSPORTNODE)
    if tnodes:
      tnode_name = tnodes[0].Name
    else:
      print 'No transport node found in the component. Create a transport node first and try again.'
      return

  setup_prop = createProperty(VC_BUTTON, 'Create Failure properties')
  setup_prop.OnChanged = setupMachine

  executeInActionPanel()

def setupMachine(arg):
  #print '-' * 20

  script = addScript('FailureHandler')
  
  addProcessModel(script)

  addScriptContent('FailureHandler', 'FailingScript.py')
  print 'To enable failure properties:'
  print 'Start and Reset the simulation'
  print 'Re-compile the FailureHandler script by opening in the script, adding a new empty line and saving the script'


def addProcessModel(script):
  transport_node = comp.findBehaviour( 'TransportNode')
  if not transport_node:
    transport_node = comp.createBehaviour('rTransportNode', 'TransportNode')
  #transport_node.ProcessExecutor = process_executor # is needed?
    transport_node.ComponentContainer = cont
    transport_node.VisualPositionFrame = p_frame
    transport_node.DefaultProductPositionFrame = p_frame
    transport_node.DefaultResourcePositionFrame = r_frame
  process_executor = comp.findBehaviour( 'ProcessExecutor__HIDE__')
  
  
  # Add statements
  process = process_executor.Processes

  if process:
    process = process[0]
  else:
    print 'ERROR: No Process found'
    return

  statement_amount = len(process.Statements)
  statement = process.addStatement(VC_STATEMENT_PROCESS, int(statement_amount/2))
  statement.getProperty('Tool').IsVisible = False
  statement.getProperty('Base').IsVisible = False
  statement.Description = 'Failing Process'
  statement.Process = script


def addScript(script_name):
  script = comp.createBehaviour(VC_PYTHONPROCESSHANDLER, script_name)
  return script


def addScriptContent(script_name, file_name):
  script = comp.findBehaviour(script_name)
  if script:
    uri = getCommandPath()[8:]
    base, filename = os.path.split(uri)
    uri = os.path.join( base, 'Templates/'+ file_name )
    with open(uri, 'r') as script_file:
      content = script_file.read()
    script.Script = content
  else:
    print 'Error with adding script content to the machine'
  return script


addState(None)

